"""Expand subscription status

Revision ID: 0156e5c17226
Revises: d65e988cd339
Create Date: 2025-03-24 15:54:12.984665

"""

# revision identifiers, used by Alembic.
revision = '0156e5c17226'
down_revision = 'd65e988cd339'

from alembic import op
import sqlalchemy as sa


def upgrade():
    op.execute("""
    CREATE TYPE subscription_status AS ENUM (
            'PENDING',
            'SETTLEMENT',
            'ACTIVE',
            'INACTIVE'
    );

    ALTER TABLE subscription
    ADD COLUMN status subscription_status NOT NULL DEFAULT 'PENDING';

    UPDATE subscription
    SET status = (CASE
        WHEN active = true
        THEN 'ACTIVE'
        ELSE 'INACTIVE' END)::subscription_status;

    ALTER TABLE subscription DROP COLUMN active;
    """)


def downgrade():
    op.execute("""
    ALTER TABLE subscription
    ADD COLUMN active boolean NOT NULL DEFAULT 'true';

    UPDATE subscription
    SET active = (status = 'ACTIVE');

    ALTER TABLE subscription DROP COLUMN status;
    DROP TYPE subscription_status;
    """)
