"""Link subscription with product ID

Revision ID: 28201884ffa5
Revises: 31db7612ce94
Create Date: 2025-03-12 16:15:00.529534

"""

# revision identifiers, used by Alembic.
revision = '28201884ffa5'
down_revision = '31db7612ce94'

from alembic import op
import sqlalchemy as sa


def upgrade():
    op.execute("""
    ALTER TABLE subscription
    ADD COLUMN product_id integer REFERENCES product(id);

    UPDATE subscription
    SET product_id = CASE
        WHEN amount in (200, 2000) THEN 1
        WHEN amount in (500, 5000) THEN 2
        WHEN amount in (1000, 10000) THEN 3
        ELSE null END;

    ALTER TABLE subscription
    ALTER COLUMN product_id SET NOT NULL,
    DROP COLUMN amount;
    """)


def downgrade():
    op.execute("""
    ALTER TABLE subscription
    ADD COLUMN amount integer;

    UPDATE subscription
    SET amount = CASE
        WHEN product_id = 1 THEN 200
        WHEN product_id = 2 THEN 500
        WHEN product_id = 3 THEN 1000
        ELSE null END
    WHERE interval = 'MONTHLY';

    UPDATE subscription
    SET amount = CASE
        WHEN product_id = 1 THEN 2000
        WHEN product_id = 2 THEN 5000
        WHEN product_id = 3 THEN 10000
        ELSE null END
    WHERE interval = 'ANNUALLY';

    ALTER TABLE subscription
    ALTER COLUMN amount SET NOT NULL,
    DROP COLUMN product_id;
    """)
