"""Add monotonic invoice number

Revision ID: d65e988cd339
Revises: 351c45247a68
Create Date: 2025-03-19 10:56:53.659942

"""

# revision identifiers, used by Alembic.
revision = 'd65e988cd339'
down_revision = '351c45247a68'

from alembic import op
import sqlalchemy as sa


def upgrade():
    op.execute("""
    ALTER TABLE "user"
    ADD COLUMN next_invoice_no integer NOT NULL DEFAULT 1;

    ALTER TABLE invoice
    ADD COLUMN invoice_no integer;

    UPDATE invoice
    SET invoice_no = id;

    ALTER TABLE invoice
    ALTER COLUMN invoice_no SET NOT NULL;

    CREATE UNIQUE INDEX
    invoice_user_id_invoice_no_key
    ON invoice (user_id, invoice_no);

    UPDATE "user" u SET next_invoice_no = coalesce(
        (SELECT max(invoice_no) + 1 FROM invoice WHERE user_id = u.id),
        1);
    """)


def downgrade():
    op.execute("""
    DROP INDEX invoice_user_id_invoice_no_key;
    ALTER TABLE "user" DROP COLUMN next_invoice_no;
    ALTER TABLE invoice DROP COLUMN invoice_no;
    """)
