from metasrht.types import PaymentInterval, PaymentCurrency, SubscriptionStatus
from srht.graphql import gql_time

def gql_invoice(i):
    if i is None:
        return None
    if "issued" in i:
        i["issued"] = gql_time(i["issued"])
    if "serviceStart" in i:
        i["serviceStart"] = gql_time(i["serviceStart"])
    if "serviceEnd" in i:
        i["serviceEnd"] = gql_time(i["serviceEnd"])
    return i

def gql_product(p):
    if p is None:
        return None
    if "prices" in p and all("currency" in price for price in p["prices"]):
        p["prices"] = {
            price["currency"]: price for price in p["prices"]
        }
    return p

def gql_subscription(s):
    if s is None:
        return None
    if "interval" in s:
        s["interval"] = PaymentInterval(s["interval"])
    if "product" in s:
        s["product"] = gql_product(s["product"])
    if "status" in s:
        s["status"] = SubscriptionStatus(s["status"])
    return s
